//////////////////////////////////////////////////////////////////////
// RUDI v0.1 - an open source Christmas game
// Copyright (C) 2007 Christian Behrenberg
//--------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//--------------------------------------------------------------------
// module       : camera -- HEADER
// created (by) : Christian Behrenberg, 2007-10-10
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// PROTOTYPES
//--------------------------------------------------------------------

	void cam_update ();
	void cam_setOffset (VECTOR* offset);
	void cam_setArc (var arc);

//--------------------------------------------------------------------
// DEFINES
//--------------------------------------------------------------------

	#define cam_interpolate_pos	0.35
	#define cam_interpolate_ang	0.2
	
	//- standard cam preset -------------------------------------------
	VECTOR*	cam_std_offset = {x = 0; y = -900; z = 800;}
	var		cam_std_arc = 80;
	VECTOR*	cam_std_lookAt = {x = 100; y = 0; z = 0;}

	//- gate cam preset -----------------------------------------------
	var		cam_gate_arc = 90;
	VECTOR*	cam_gate_offset = {x = -50; y = -700; z = 700;}
	
	//- rudi death preset ---------------------------------------------
	var		cam_rudiDeath_arc = 70;
	VECTOR*	cam_rudiDeath_offset = {x = 0; y = -500; z = 600;}

//--------------------------------------------------------------------
// VARIABLES
//--------------------------------------------------------------------

	var		cam_arc_target;
	VECTOR	cam_offset_target;