//////////////////////////////////////////////////////////////////////
// RUDI v0.1 - an open source Christmas game
// Copyright (C) 2007 Christian Behrenberg
//--------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//--------------------------------------------------------------------
// shader       : shiny shader
// created (by) : Christian Behrenberg, 2007-11-17
//--------------------------------------------------------------------

texture entSkin1;
texture mtlSkin1;
matrix matMtl;

technique envmap
{
	pass p0 {

 		zWriteEnable=true;
 		alphaBlendEnable=false;

 		textureFactor=0x30FFFFFF; // -> C0=75%, 80=50%, 40=25%

 		texture[0]=<entSkin1>;
 		colorArg1[0]=Texture;
 		colorOp[0]=Modulate2x;
 		colorArg2[0]=Diffuse;

		texture[1]=<mtlSkin1>;
		colorArg1[1]=Texture;
		colorOp[1]=blendFactorAlpha;
		addressU[1]=Clamp;
		addressV[1]=Clamp;
		texCoordIndex[1]=cameraSpaceReflectionVector;
		textureTransformFlags[1]=Count3;
		textureTransform[1]=<matMtl>; // transform camera space back to world space

	}
}