//////////////////////////////////////////////////////////////////////
// RUDI v0.1 - an open source Christmas game
// Copyright (C) 2007 Christian Behrenberg
//--------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//--------------------------------------------------------------------
// module       : menu
// created (by) : Christian Behrenberg, 2007-11-03
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// MAIN MENU FUNCTION - RUNS ALL THE TIME
//--------------------------------------------------------------------
void menu_main ()
{
	menu_init();

	// First time: play music
		music_menu_start();

	while (1) {
		
		// Refresh panels
			menu_refresh_all();
			
		// Make a check for an ingame-menu call
			menu_game_open();

		switch (menu_mode) {
			case MENU_MODE_NONE:											break;
			case MENU_MODE_MAIN:			menu_main_show();			break;
			case MENU_MODE_CFG:			menu_cfg_show();			break;
			case MENU_MODE_GAMEOVER:	menu_gameover_show();	break;
			case MENU_MODE_GAME:			menu_game_show();			break;
			case MENU_MODE_STORY:		menu_story_show();		break;
		}

		wait(1);
	}
}

	//-----------------------------------------------------------------
	// LOADS ALL RESSOURCES
	//-----------------------------------------------------------------
	void menu_init ()
	{
		// GENERAL
	
			menu_cursorBmap = bmap_create("menu_cursor.dds");

		// MAIN MENU

			menu_background = pan_createEx("", 100, "menu_background.tga", 0, 0, 0);

			menu_startGame = pan_createEx("button(0,0, menu_startGame_n.dds, menu_startGame_n.dds, menu_startGame_t.dds, menu_main_startGame, NULL, snd_menu_itemTouchPlay);", 101, NULL, 0, 0, 0);
			menu_config = pan_createEx("button(0,0, menu_config_n.dds, menu_config_n.dds, menu_config_t.dds, menu_main_config, NULL, snd_menu_itemTouchPlay);", 101, NULL, 0, 0, 0);
			menu_credits = pan_createEx("button(0,0, menu_credits_n.dds, menu_credits_n.dds, menu_credits_t.dds, menu_main_credits, NULL, snd_menu_itemTouchPlay);", 101, NULL, 0, 0, 0);
			menu_exit = pan_createEx("button(0,0, menu_exit_n.dds, menu_exit_n.dds, menu_exit_t.dds, menu_main_exit, NULL, snd_menu_itemTouchPlay);", 101, NULL, 0, 0, 0);

		// STORY

			menu_story_background = pan_createEx("", 100, "menu_story_bg.tga", 0, 0, 0);
			menu_story_panelA = pan_createEx("", 101, "menu_story_picA.dds", 0, 0, 0);
			menu_story_panelB = pan_createEx("", 102, "menu_story_picB.dds", 0, 0, 0);
			menu_story_panelC = pan_createEx("", 103, "menu_story_picC.dds", 0, 0, 0);
			menu_story_panelD = pan_createEx("", 104, "menu_story_picD.dds", 0, 0, 0);

		// CONFIG

			menu_cfg_background = pan_createEx("", 200, "menu_cfg_bg.tga", 0, 0, 0);
			menu_cfg_header = pan_createEx("", 201, "menu_cfg_header.dds", 0, 0, 0);
			
			menu_cfg_detailLabel = pan_createEx("", 201, "menu_cfg_detailLabel.dds", 0, 0, 0);
			menu_cfg_detail = pan_createEx("	button_radio(0, 0, menu_cfg_detailLow_c.dds, menu_cfg_detailLow_u.dds, menu_cfg_detailLow_u.dds, menu_cfg_setDetail, NULL, NULL);
														button_radio(93, 0, menu_cfg_detailMed_c.dds, menu_cfg_detailMed_u.dds, menu_cfg_detailMed_u.dds, menu_cfg_setDetail, NULL, NULL);
														button_radio(246, 0, menu_cfg_detailHigh_c.dds, menu_cfg_detailHigh_u.dds, menu_cfg_detailHigh_u.dds, menu_cfg_setDetail, NULL, NULL);",
														201, NULL, 0, 0, 0);
														
			menu_cfg_detailBlock = pan_createEx("", 202, "menu_cfg_detailBlock.dds", 0, 0, 0);

			menu_cfg_resLabel = pan_createEx("", 201, "menu_cgf_resLabel.dds", 0, 0, 0);
			menu_cfg_res = pan_createEx("	button_radio(0, 0, menu_cfg_res640_c.dds, menu_cfg_res640_u.dds, menu_cfg_res640_u.dds, menu_cfg_setRes, NULL, NULL);
													button_radio(192, 10, menu_cfg_res800_c.dds, menu_cfg_res800_u.dds, menu_cfg_res800_u.dds, menu_cfg_setRes, NULL, NULL);
													button_radio(385, 0, menu_cfg_res1024_c.dds, menu_cfg_res1024_u.dds, menu_cfg_res1024_u.dds, menu_cfg_setRes, NULL, NULL);
													button_radio(588, 0, menu_cfg_res2048_c.dds, menu_cfg_res2048_u.dds, menu_cfg_res2048_u.dds, menu_cfg_setRes, NULL, NULL);",
													201, NULL, 0, 0, 0);

			menu_cfg_dot = bmap_create("menu_cfg_volDot.dds");
			menu_cfg_volume = pan_createEx("	hslider(261, 16, 188, menu_cfg_dot, 0, 100, volMusic);
														hslider(604, 16, 188, menu_cfg_dot, 0, 100, volSfx);",
														201, "menu_cfg_volBars.dds", 0, 0, 0);

			menu_cfg_OK = pan_createEx("button(0,0, menu_cfg_OK_n.dds, menu_cfg_OK_n.dds, menu_cfg_OK_t.dds, menu_cfg_main, NULL, snd_menu_itemTouchPlay);", 201, NULL, 0, 0, 0);

		// INGAME MENU
		
			menu_game_background	= pan_createEx("", 200, "menu_game_bg.dds", 0, 0, 0);
			menu_game_continue	= pan_createEx("button(0,0, menu_game_continue_n.dds, menu_game_continue_n.dds, menu_game_continue_t.dds, menu_game_continueGame, NULL, snd_menu_itemTouchPlay);", 201, NULL, 0, 0, 0);
			menu_game_config		= pan_createEx("button(0,0, menu_game_cfg_n.dds, menu_game_cfg_n.dds, menu_game_cfg_t.dds, menu_game_openConfig, NULL, snd_menu_itemTouchPlay);", 201, NULL, 0, 0, 0);
			menu_game_back			= pan_createEx("button(0,0, menu_game_back_n.dds, menu_game_back_n.dds, menu_game_back_t.dds, menu_game_mainmenu, NULL, snd_menu_itemTouchPlay);", 201, NULL, 0, 0, 0);

		// GAME OVER

			menu_gameover_background = pan_createEx("", 100, "menu_gameover_bg.tga", 0, 0, 0);
			menu_gameover_retry = pan_createEx("button(0,0, menu_gameover_retry_n.dds, menu_gameover_retry_n.dds, menu_gameover_retry_t.dds, menu_gameover_restartGame, NULL, snd_menu_itemTouchPlay);", 101, NULL, 0, 0, 0);
			menu_gameover_back = pan_createEx("button(0,0, menu_gameover_back_n.dds, menu_gameover_back_n.dds, menu_gameover_back_t.dds, menu_gameover_main, NULL, snd_menu_itemTouchPlay);", 101, NULL, 0, 0, 0);
			menu_gameover_exit = pan_createEx("button(0,0, menu_gameover_exit_n.dds, menu_gameover_exit_n.dds, menu_gameover_exit_t.dds, menu_gameover_quitGame, NULL, snd_menu_itemTouchPlay);", 101, NULL, 0, 0, 0);

		// GENERAL
		
			menu_pressAnyKey = pan_createEx("", 999, "menu_pressAnyKey.dds", 0, 0, 0);

		// VARIABLES

			menu_mode = MENU_MODE_MAIN;
	}

//--------------------------------------------------------------------
// MAIN MENU DIALOG
//--------------------------------------------------------------------
void menu_main_show ()
{
	//make sure, that the Rudi-pointer isn't filled
	Rudi = NULL;
	
	hud_hide();					//hide HUD
	menu_hide_all();			//hide all elements
	menu_main_elements();	//show selected elements
	menu_cursor();				//draw cursor
}

	//- shows all necessary gui elements ------------------------------
	void menu_main_elements ()
	{
		set(menu_background, VISIBLE);
		set(menu_startGame, VISIBLE);
		set(menu_config, VISIBLE);
		set(menu_credits, VISIBLE);
		set(menu_exit, VISIBLE);
	}

	//- EVENT - starts the game ---------------------------------------
	void menu_main_startGame ()
	{
		snd_menu_startGamePlay();

		menu_story_init();
		menu_mode = MENU_MODE_STORY;
	}

	//- EVENT - show config -------------------------------------------
	void menu_main_config ()
	{
		snd_menu_itemClickPlay();

		menu_cfg_blockDetail = 0;
		menu_mode = MENU_MODE_CFG;
	}

	//- EVENT - show credits ------------------------------------------
	void menu_main_credits ()
	{
		snd_menu_itemClickPlay();

		cr_stoppable = 1;
		cr_load();
	}

	//- EVENT - exit --------------------------------------------------
	void menu_main_exit ()
	{
		snd_menu_itemClickPlay();

		music_menu_stop();
		sys_exit("");
	}

//--------------------------------------------------------------------
// CONFIGURATION DIALOG
//--------------------------------------------------------------------
void menu_cfg_show ()
{
	if (!Rudi) {	// Started from main menu
		hud_hide(); // Hide HUD
	}

	menu_hide_all();			// Hide all elements
	menu_cfg_setValues();	// Set all configurable values
	menu_cfg_elements();		// Show selected elements
	menu_cursor();				// Draw cursor
}

	//- retrieves values and sets the radio buttons --------------------
	void menu_cfg_setValues ()
	{
		// Detail
			switch (detail) {
				case DETAIL_LOW:		button_state(menu_cfg_detail, 1, 1); break;
				case DETAIL_MEDIUM:	button_state(menu_cfg_detail, 2, 1); break;
				case DETAIL_HIGH:		button_state(menu_cfg_detail, 3, 1); break;
			}

		// Videomode
			switch (video_mode) {
				case 6: button_state(menu_cfg_res, 1, 1); break;
				case 7: button_state(menu_cfg_res, 2, 1); break;
				case 8: button_state(menu_cfg_res, 3, 1); break;
				case 9: button_state(menu_cfg_res, 4, 1); break;
			}

		// Update music volume

			// Only when left mouse button is pressed to pull the sliders
				if (mouse_left) {
					if (media_playing(music_menu))	{media_tune(music_menu, volMusic, 0, 0);}
					if (media_playing(music_level))	{media_tune(music_level, volMusic, 0, 0);}
				}
	}

	//- Shows the dialog elements --------------------------------------
	void menu_cfg_elements ()
	{
		set(menu_cfg_background, VISIBLE);
		set(menu_cfg_header, VISIBLE);
	
		set(menu_cfg_detailLabel, VISIBLE);
		set(menu_cfg_detail, VISIBLE);
		
			reset(menu_cfg_detailLabel, TRANSLUCENT);
			reset(menu_cfg_detail, TRANSLUCENT);
			reset(menu_cfg_detailBlock, VISIBLE);

			menu_cfg_detailLabel->alpha = 100;
			menu_cfg_detail->alpha = 100;

			if (menu_cfg_blockDetail) {

				set(menu_cfg_detailLabel, TRANSLUCENT);
				set(menu_cfg_detail, TRANSLUCENT);

				menu_cfg_detailLabel->alpha = 25;
				menu_cfg_detail->alpha = 25;

				set(menu_cfg_detailBlock, VISIBLE);
			}

		set(menu_cfg_resLabel, VISIBLE);
		set(menu_cfg_res, VISIBLE);
		set(menu_cfg_volume, VISIBLE);
		set(menu_cfg_OK, VISIBLE);
	}
	
	//- EVENT - set detail --------------------------------------------
	void menu_cfg_setDetail (var buttonNr)
	{
		snd_menu_itemClickPlay();

		detail = buttonNr - 1;
	}
	
	//- EVENT - set resolution ----------------------------------------
	void menu_cfg_setRes (var buttonNr)
	{
		snd_menu_itemClickPlay();

		video_switch(5 + buttonNr, 0, 0);
	}

	//- EVENT - back to main menu -------------------------------------
	void menu_cfg_main ()
	{
		snd_menu_itemClickPlay();

		if (!Rudi) {
			menu_mode = MENU_MODE_MAIN;
		} else {
			menu_mode = MENU_MODE_GAME;
		}
	}

//--------------------------------------------------------------------
// STORY DIALOG
//--------------------------------------------------------------------
void menu_story_show ()
{
	menu_hide_all();			//hide all elements
	menu_story_elements();	//show selected elements

	menu_story_run();			//run story-script
}

	//- Initializes the story dialog -----------------------------------
	void menu_story_init ()
	{
		// Reset timer
		menu_story_time = 0;

		music_story_start();

		menu_story_panelA->alpha = 0;
		menu_story_panelB->alpha = 0;
		menu_story_panelC->alpha = 0;
		menu_story_panelD->alpha = 0;

		reset(menu_pressAnyKey, VISIBLE);

		// Wait until the key has been released
			menu_story_anykey_ready = 0;
			while (key_any) {wait(1);}
			menu_story_anykey_ready = 1;
	}

	//- Shows the dialog elements --------------------------------------
	void menu_story_elements ()
	{
		// Background
			set(menu_story_background, VISIBLE);

		// Story panels
			set(menu_story_panelA, VISIBLE | TRANSLUCENT);
			set(menu_story_panelB, VISIBLE | TRANSLUCENT);
			set(menu_story_panelC, VISIBLE | TRANSLUCENT);
			set(menu_story_panelD, VISIBLE | TRANSLUCENT);
	}

	//- Story ----------------------------------------------------------
	void menu_story_run ()
	{
		// Timer
			menu_story_time += time_step;

		// Fade panels (according to their timecode)
			menu_story_panelA->alpha += (menu_story_time > menu_story_panelA_start * 16) * menu_story_panelA_speed * time_step;
			menu_story_panelB->alpha += (menu_story_time > menu_story_panelB_start * 16) * menu_story_panelB_speed * time_step;
			menu_story_panelC->alpha += (menu_story_time > menu_story_panelC_start * 16) * menu_story_panelC_speed * time_step;
			menu_story_panelD->alpha += (menu_story_time > menu_story_panelD_start * 16) * menu_story_panelD_speed * time_step;
			
		if (menu_story_time > menu_story_anykey * 16) {
			set(menu_pressAnyKey, VISIBLE);
		} else {
			reset(menu_pressAnyKey, VISIBLE);
		}

		// Cancel story and start game when anykey is pressed
		// After a certain time, we automatically start the game

			if (((menu_story_anykey_ready) && (key_any)) || (menu_story_time > menu_story_end * 16)) {
				reset(menu_pressAnyKey, VISIBLE);
				game_start(); //start game
			}
	}

//--------------------------------------------------------------------
// INGAME MENU DIALOG
//--------------------------------------------------------------------
void menu_game_show ()
{
	lvl_stopSnd();

	menu_hide_all();				//hide all elements
	menu_game_elements();	//show selected elements
	menu_cursor();					//draw cursor

	if ((key_esc)&&(menu_game_keyEsc == 0)) {
		menu_game_keyEsc = 1;
		menu_game_continueGame();
		while (key_esc) {wait(1);}
		menu_game_keyEsc = 0;
	}
}

	//- Opens the game menu --------------------------------------------
	void menu_game_open ()
	{
		if (((Rudi != NULL) && (menu_mode == MENU_MODE_NONE)) &&
			(menu_game_keyEsc == 0))
		{
			if (key_esc) {
				freeze_mode = 1;
				menu_mode = MENU_MODE_GAME;
				snd_menu_itemClickPlay();
				menu_game_keyEsc = 1;
				while (key_esc) {wait(1);}
				menu_game_keyEsc = 0;
			}
		}
	}

	//- Shows the dialog elements --------------------------------------
	void menu_game_elements ()
	{
		set(menu_game_background, VISIBLE);
		set(menu_game_continue, VISIBLE);
		set(menu_game_config, VISIBLE);
		set(menu_game_back, VISIBLE);
	}
	
	//- EVENT - continue ----------------------------------------------
	void menu_game_continueGame ()
	{
		snd_menu_itemClickPlay();

		menu_mode = MENU_MODE_NONE;
		menu_hide_all();
		freeze_mode = 0;
	}
	
	//- EVENT - config ------------------------------------------------
	void menu_game_openConfig ()
	{
		snd_menu_itemClickPlay();

		menu_cfg_blockDetail = 1;
		menu_mode = MENU_MODE_CFG;
	}

	//- EVENT - back to main menu -------------------------------------
	void menu_game_mainmenu ()
	{
		snd_menu_itemClickPlay();
		menu_mode = MENU_MODE_MAIN;
		music_menu_start();
		level_load("");
	}

//--------------------------------------------------------------------
// GAMEOVER DIALOG
//--------------------------------------------------------------------
void menu_gameover_show ()
{
	lvl_stopSnd();
	
	hud_hide();						//hide HUD
	menu_hide_all();				//hide all elements
	menu_gameover_elements();	//show selected elements
	menu_cursor();					//draw cursor
}

	//- shows all necessary gui elements ------------------------------
	void menu_gameover_elements ()
	{
		set(menu_gameover_background, VISIBLE);
		set(menu_gameover_retry, VISIBLE);
		set(menu_gameover_back, VISIBLE);
		set(menu_gameover_exit, VISIBLE);
	}

	//- EVENT - restart game ------------------------------------------
	void menu_gameover_restartGame ()
	{
		snd_menu_startGamePlay();

		game_start(); //restart game
	}

	//- EVENT - back to main menu -------------------------------------
	void menu_gameover_main ()
	{
		snd_menu_itemClickPlay();

		music_menu_start();
		menu_mode = MENU_MODE_MAIN;
	}

	//- EVENT - back to main menu -------------------------------------
	void menu_gameover_quitGame ()
	{
		snd_menu_itemClickPlay();

		sys_exit("");
	}

//--------------------------------------------------------------------
// DRAWS THE MENU CURSOR
//--------------------------------------------------------------------
void menu_cursor ()
{
	mouse_map = menu_cursorBmap;
	mouse_mode = 4;
}

//--------------------------------------------------------------------
// HIDES ALL ELEMENTS
//--------------------------------------------------------------------
void menu_hide_all ()
{
	// MAIN MENU
		reset(menu_background, VISIBLE);
		reset(menu_startGame, VISIBLE);
		reset(menu_config, VISIBLE);
		reset(menu_credits, VISIBLE);
		reset(menu_exit, VISIBLE);

	// CONFIGURATION
		reset(menu_cfg_background, VISIBLE);
		reset(menu_cfg_header, VISIBLE);
		reset(menu_cfg_detailLabel, VISIBLE);
		reset(menu_cfg_detailBlock, VISIBLE);
		reset(menu_cfg_detail, VISIBLE);
		reset(menu_cfg_resLabel, VISIBLE);
		reset(menu_cfg_res, VISIBLE);
		reset(menu_cfg_volume, VISIBLE);
		reset(menu_cfg_OK, VISIBLE);
		
	// STORY
		reset(menu_story_background, VISIBLE);
		reset(menu_story_panelA, VISIBLE);
		reset(menu_story_panelB, VISIBLE);
		reset(menu_story_panelC, VISIBLE);
		reset(menu_story_panelD, VISIBLE);

	// INGAME MENU
		reset(menu_game_background, VISIBLE);
		reset(menu_game_continue, VISIBLE);
		reset(menu_game_config, VISIBLE);
		reset(menu_game_back, VISIBLE);

	// GAME OVER
		reset(menu_gameover_background, VISIBLE);
		reset(menu_gameover_retry, VISIBLE);
		reset(menu_gameover_back, VISIBLE);
		reset(menu_gameover_exit, VISIBLE);

	// MOUSE
		mouse_mode = 0;
}

//--------------------------------------------------------------------
// REFRESHES ALL ELEMENTS
//--------------------------------------------------------------------
void menu_refresh_all ()
{
	// MAIN MENU
		ri_refreshPanel(menu_background, menu_background_pos);
		ri_refreshPanel(menu_startGame, menu_startGame_pos);
		ri_refreshPanel(menu_config, menu_config_pos);
		ri_refreshPanel(menu_credits, menu_credits_pos);
		ri_refreshPanel(menu_exit, menu_exit_pos);

	// CONFIG
		ri_refreshPanel(menu_cfg_background, menu_cfg_bg_pos);
		ri_refreshPanel(menu_cfg_header, menu_cfg_header_pos);
		ri_refreshPanel(menu_cfg_detailLabel, menu_cfg_detailLabel_pos);
		ri_refreshPanel(menu_cfg_detailBlock, menu_cfg_detailBlock_pos);
		ri_refreshPanel(menu_cfg_detail, menu_cfg_detail_pos);
		ri_refreshPanel(menu_cfg_resLabel, menu_cfg_resLabel_pos);
		ri_refreshPanel(menu_cfg_res, menu_cfg_res_pos);
		ri_refreshPanel(menu_cfg_volume, menu_cfg_vol_pos);
		ri_refreshPanel(menu_cfg_OK, menu_cfg_OK_pos);

	// STORY
		ri_refreshPanel(menu_story_background, menu_story_background_pos);
		ri_refreshPanel(menu_story_panelA, menu_story_panelA_pos);
		ri_refreshPanel(menu_story_panelB, menu_story_panelB_pos);
		ri_refreshPanel(menu_story_panelC, menu_story_panelC_pos);
		ri_refreshPanel(menu_story_panelD, menu_story_panelD_pos);

	// INGAME MENU
		ri_refreshPanel(menu_game_background, menu_game_background_pos);
		ri_refreshPanel(menu_game_continue, menu_game_continue_pos);
		ri_refreshPanel(menu_game_config, menu_game_cfg_pos);
		ri_refreshPanel(menu_game_back, menu_game_back_pos);

	// GAMEOVER
		ri_refreshPanel(menu_gameover_background, menu_gameover_background_pos);
		ri_refreshPanel(menu_gameover_retry, menu_gameover_retry_pos);
		ri_refreshPanel(menu_gameover_back, menu_gameover_back_pos);
		ri_refreshPanel(menu_gameover_exit, menu_gameover_exit_pos);

	// GENERAL
		ri_refreshPanel(menu_pressAnyKey, menu_pressAnyKey_pos);
}