//////////////////////////////////////////////////////////////////////
// RUDI v0.1 - an open source Christmas game
// Copyright (C) 2007 Christian Behrenberg
//--------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//--------------------------------------------------------------------
// module       : menu -- HEADER
// created (by) : Christian Behrenberg, 2007-11-03
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// PROTOTYPE HIERARCHY
//--------------------------------------------------------------------

	void menu_main();
		void menu_init();
	void menu_main_show();
		void menu_main_elements();
		void menu_cursor();
		void menu_main_startGame();
		void menu_main_config();
		void menu_main_credits();
		void menu_main_exit();
	void menu_cfg_show();
		void menu_cfg_setValues();
		void menu_cfg_elements();
		void menu_cfg_setDetail (var buttonNr);
		void menu_cfg_setRes (var buttonNr);
		void menu_cfg_main();
	void menu_story_show();
		void menu_story_init();
		void menu_story_elements();
		void menu_story_run();
	void menu_game_show();
		void menu_game_open();
		void menu_game_elements();
		void menu_game_continueGame();
		void menu_game_openConfig();
		void menu_game_mainmenu();
	void menu_gameover_show();
		void menu_gameover_elements();
		void menu_gameover_main();
		void menu_gameover_quitGame();
	void menu_hide_all();
	void menu_refresh_all();

//--------------------------------------------------------------------
// DEFINES
//--------------------------------------------------------------------

	#define MENU_STORY_PANELS_CNT 4

//--------------------------------------------------------------------
// RESSOURCES
//--------------------------------------------------------------------

	// GENERAL
		BMAP*	menu_cursorBmap;

	// MAIN MENU
		PANEL* menu_background;
		PANEL* menu_startGame;
		PANEL* menu_config;
		PANEL* menu_credits;
		PANEL* menu_exit;

	// CONFIG
		PANEL* menu_cfg_background;
		PANEL* menu_cfg_header;
		PANEL* menu_cfg_detail;
		PANEL* menu_cfg_detailLabel;
		PANEL* menu_cfg_detailBlock;
		PANEL* menu_cfg_res;
		PANEL* menu_cfg_resLabel;
		PANEL* menu_cfg_volume;
			BMAP* menu_cfg_dot;
		PANEL* menu_cfg_OK;
		
	//STORY
		PANEL* menu_story_background;
		PANEL* menu_story_panelA;
		PANEL* menu_story_panelB;
		PANEL* menu_story_panelC;
		PANEL* menu_story_panelD;

	// INGAME MENU
		PANEL* menu_game_background;
		PANEL* menu_game_continue;
		PANEL* menu_game_config;
		PANEL* menu_game_back;

	// GAMEOVER
		PANEL* menu_gameover_background;
		PANEL* menu_gameover_retry;
		PANEL* menu_gameover_back;
		PANEL* menu_gameover_exit;

	// GENERAL
		PANEL* menu_pressAnyKey;

//--------------------------------------------------------------------
// VARIABLES
//--------------------------------------------------------------------

	var menu_mode;

		#define MENU_MODE_NONE		0
		#define MENU_MODE_MAIN		1
		#define MENU_MODE_CFG		2
		#define MENU_MODE_GAMEOVER	3
		#define MENU_MODE_GAME		4
		#define MENU_MODE_STORY		5
		#define MENU_MODE_CREDITS	6
		
	// CFG MENU
		var menu_cfg_blockDetail;

	// STORY
		var menu_story_time;
		var menu_story_anykey_ready;
		
	// GAME MENU
		var menu_game_keyEsc;

//--------------------------------------------------------------------
// CONSTANTS
//--------------------------------------------------------------------

	// STORY TIMING

		var menu_story_panelA_start = 1.2; //start time in seconds
			var menu_story_panelA_speed = 0.19; //fade speed in percent per tick

		var menu_story_panelB_start = 14.3;
			var menu_story_panelB_speed = 0.19;

		var menu_story_panelC_start = 31.2;
			var menu_story_panelC_speed = 0.19;

		var menu_story_panelD_start = 45.1;
			var menu_story_panelD_speed = 0.22;

		var menu_story_anykey = 58;

		var menu_story_end = 112;	// after x seconds we start the game

//--------------------------------------------------------------------
// LAYOUT
//--------------------------------------------------------------------

	// MAIN MENU

		VECTOR* menu_background_pos				= {x = 0;	y = 0;	z = 0;}
		VECTOR* menu_startGame_pos					= {x = 103;	y = 430;	z = 0;}
		VECTOR* menu_config_pos						= {x = 131;	y = 588;	z = 0;}
		VECTOR* menu_credits_pos					= {x = 132;	y = 645;	z = 0;}
		VECTOR* menu_exit_pos						= {x = 143;	y = 702;	z = 0;}

	// CONFIG

		VECTOR* menu_cfg_bg_pos						= {x = 0;	y = 0;	z = 0;}
		VECTOR* menu_cfg_header_pos				= {x = 277;	y = 34;	z = 0;}
		VECTOR* menu_cfg_detailLabel_pos			= {x = 287;	y = 210;	z = 0;}
		VECTOR* menu_cfg_detailBlock_pos			= {x = 413; y = 196; z = 0;}
		VECTOR* menu_cfg_detail_pos				= {x = 429;	y = 210;	z = 0;}
		VECTOR* menu_cfg_resLabel_pos				= {x = 61;	y = 330;	z = 0;}
		VECTOR* menu_cfg_res_pos					= {x = 185;	y = 315;	z = 0;}
		VECTOR* menu_cfg_vol_pos					= {x = 112;	y = 451;	z = 0;}
		VECTOR* menu_cfg_OK_pos						= {x = 483;	y = 562;	z = 0;}

	// STORY

		VECTOR* menu_story_background_pos		= {x = 0;	y = 0;	z = 0;}
		VECTOR* menu_story_panelA_pos				= {x = 26;	y = 33;	z = 0;}
		VECTOR* menu_story_panelB_pos				= {x = 451; y = 44;	z = 0;}
		VECTOR* menu_story_panelC_pos				= {x = 31;	y = 365;	z = 0;}
		VECTOR* menu_story_panelD_pos				= {x = 447;	y = 401;	z = 0;}

	// INGAME MENU

		VECTOR* menu_game_background_pos			= {x = 0;	y = 0;	z = 0;}
		VECTOR* menu_game_continue_pos			= {x = 409;	y = 204;	z = 0;}
		VECTOR* menu_game_cfg_pos					= {x = 344;	y = 337;	z = 0;}
		VECTOR* menu_game_back_pos					= {x = 371;	y = 470;	z = 0;}

	// GAMEOVER

		VECTOR* menu_gameover_background_pos	= {x = 0;	y = 0;	z = 0;}
		VECTOR* menu_gameover_retry_pos			= {x = 273;	y = 488;	z = 0;}
		VECTOR* menu_gameover_back_pos			= {x = 487;	y = 513;	z = 0;}
		VECTOR* menu_gameover_exit_pos			= {x = 716;	y = 543;	z = 0;}

	// GENERAL

		VECTOR* menu_pressAnyKey_pos				= {x = 567; y = 677; z = 0;}