//////////////////////////////////////////////////////////////////////
// RUDI v0.1 - an open source Christmas game
// Copyright (C) 2007 Christian Behrenberg
//--------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//--------------------------------------------------------------------
// module       : music
// created (by) : Christian Behrenberg, 2007-12-01
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// SPLASH MUSIC
//--------------------------------------------------------------------

	void music_splash_start ()
	{
		music_splash = media_play(music_splashFile, NULL, volMusic);
	}
	
	void music_splash_stop ()
	{
		media_stop(music_splash);
	}

//--------------------------------------------------------------------
// MENU MUSIC
//--------------------------------------------------------------------

	void music_menu_start ()
	{
		music_splash_stop();
		music_level_stop();
		music_gameOver_stop();
		music_credits_stop();
	
		music_menu = media_loop(music_menuFile, NULL, volMusic);
	}
	
	void music_menu_stop ()
	{
		media_stop(music_menu);
	}

//--------------------------------------------------------------------
// STORY MUSIC
//--------------------------------------------------------------------

	void music_story_start ()
	{
		music_menu_stop();
		
		music_story 		= media_play(music_storyFile, NULL, volMusic * 0.8);
		music_storySpeech	= media_play(music_storySpeechFile, NULL, volMusic);
	}
	
	void music_story_stop ()
	{
		media_stop(music_story);
		media_stop(music_storySpeech);
	}

//--------------------------------------------------------------------
// LEVEL MUSIC
//--------------------------------------------------------------------

	//-----------------------------------------------------------------
	// Uses the text "music_levelFiles" as playlist and plays the list
	// in loop.
	//-----------------------------------------------------------------
	void music_level_start ()
	{
		music_menu_stop();
		music_story_stop();
	
		music_levelFiles_current %= (int)(music_levelFiles->strings);
		music_level = media_play((music_levelFiles.pstring)[music_levelFiles_current], NULL, volMusic);
	
		while ((music_level != 0) && (media_playing(music_level))) {wait(1);}

		wait(1);
	
		if (media_playing(music_menu))		{return;}
		if (media_playing(music_gameOver))	{return;}
		if (media_playing(music_credits))	{return;}
	
		music_levelFiles_current++;
		music_level_start();
	}
	
	void music_level_stop ()
	{
		media_stop(music_level);
		music_menu = 0;
	}

//--------------------------------------------------------------------
// GAME OVER MUSIC
//--------------------------------------------------------------------

	void music_gameOver_start ()
	{
		music_level_stop();
	
		music_gameOver = media_loop(music_gameOverFile, NULL, volMusic);
	}
	
	void music_gameOver_stop ()
	{
		media_stop(music_gameOver);
	}

//--------------------------------------------------------------------
// CREDITS MUSIC
//--------------------------------------------------------------------

	void music_credits_start ()
	{
		music_menu_stop();
		music_level_stop();
	
		music_credits = media_play(music_creditsFile, NULL, volMusic);
	}
	
	void music_credits_stop ()
	{
		media_stop(music_credits);
	}