//////////////////////////////////////////////////////////////////////
// RUDI v0.1 - an open source Christmas game
// Copyright (C) 2007 Christian Behrenberg
//--------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//--------------------------------------------------------------------
// module       : player -- HEADER
// created (by) : Christian Behrenberg, 2007-10-10
//--------------------------------------------------------------------

int lock;

//--------------------------------------------------------------------
// prototypes
//--------------------------------------------------------------------

	void pl_rudi();
		void pl_rudi_init();
			void pl_rudi_init_shad();
	void pl_event();
	void pl_turn();
	void pl_gravity();
	void pl_move();
		void pl_move_snowSplat();
	void pl_animate();
	void pl_interpolate();
	void pl_log();
	void pl_death();
		void pl_death_crash();
			void pl_death_crash_cam ();
		void pl_death_levelend();

//--------------------------------------------------------------------
// defines
//--------------------------------------------------------------------

	#define moveDir		skill1	//2,3
	#define height			skill4
	#define logPos			skill5	//6,7
	#define animCounter  skill8
	#define sledgeFirst	skill9
	#define sledgeLast	skill10
	#define playerDeath	skill11
	#define playerBridle	skill12

	#define pl_turn_blendFac					0.8
	#define pl_move_marginOffset  			10
	#define pl_lerp_surfaceAng_fac			0.25
	#define pl_lerp_surfaceAng_threshold	10

	var pl_gravitation = 90;

//--------------------------------------------------------------------
// general variables
//--------------------------------------------------------------------

	ENTITY* Rudi;

	var	pl_move_speed = 48;

	var	pl_anim_move_threshold = 2;

	var	pl_anim_walk_speed = 12;
	char*	pl_anim_walk_frame = "walk";

	var	pl_anim_idle_speed = 3;
	char*	pl_anim_idle_frame = "idle";

	var	pl_death_stayTime = 3; //seconds
	var	pl_death_levelWaitTime = 2.5; //seconds
	
	VECTOR pl_listener;
	
	var PL_DEATH_WATERHEIGTH = -250;
	
//--------------------------------------------------------------------
// logging
//--------------------------------------------------------------------

	TRACK* trackRudi = 0;
	int	pl_track_logDist	= 60;
	int	pl_track_points	= 500;
