//////////////////////////////////////////////////////////////////////
// RUDI v0.1 - an open source Christmas game
// Copyright (C) 2007 Christian Behrenberg
//--------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//--------------------------------------------------------------------
// module       : sounds -- HEADER
// created (by) : Christian Behrenberg, 2007-12-09
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// PROTOTYPE HIERARCHY
//--------------------------------------------------------------------

	void snd_startup ();
	void snd_emitByEntDist (ENTITY* entMy, VECTOR* listener, var dist, void* playSnd, void* stopSnd);
	void lvl_stopSnd ();
	
	// PLAYER SOUNDS
			void snd_pl_walkPlay ();
			void snd_pl_walkStop ();
			void snd_pl_cut ();
			void snd_pl_splash ();
			void snd_pl_crash ();
			void snd_pk_collect ();
	
	// ENVIRONMENTAL SOUNDS
			void snd_env_windPlay ();
			void snd_env_windStop ();
			void snd_env_waterPlay ();
			void snd_env_waterStop ();
			void snd_env_waterWindPlay ();
			void snd_env_waterWindStop ();
			void snd_env_gullsPlay ();
			void snd_env_gullsStop ();
	
	// OBJECT SOUNDS
			void snd_obj_firePlay ();
			void snd_obj_fireStop ();
			void snd_obj_gateBellPlay ();
	
	// NPC SOUNDS
			void snd_esk_crashPlay ();
			void snd_pen_crashPlay ();
	
	// MENU SOUNDS
			void snd_menu_startGamePlay ();
			void snd_menu_itemTouchPlay ();
			void snd_menu_itemClickPlay ();
			
//--------------------------------------------------------------------
// SOUND OBJECTS
//--------------------------------------------------------------------

	// PLAYER SOUNDS
		SOUND* sndRudi_walk;
			var sndRudi_walkHndl;
		SOUND* sndRudi_cut;
		SOUND* sndRudi_splash;
		SOUND* sndRudi_crash;
		SOUND* sndPacket_collect;

	// ENVIRONMENTAL SOUNDS
		SOUND* sndEnv_wind;
			var sndEnv_windHndl;
		SOUND* sndEnv_water;
			var sndEnv_waterHndl;
		SOUND* sndEnv_waterWind;
			var sndEnv_waterWindHndl;
		SOUND* sndEnv_gulls;
			var sndEnv_gullsHndl;

	// OBJECT SOUNDS
		SOUND* sndObj_fire;
			var sndObj_fireHndl;
		SOUND* sndObj_gateBell;

	// MENU SOUNDS
		SOUND* sndMenu_startGame;
		SOUND* sndMenu_itemTouch;
		SOUND* sndMenu_itemClick;

//--------------------------------------------------------------------
// DEFINES
//--------------------------------------------------------------------

	// NPC SOUNDS

		// Eskimo shout
			#define SNDESK_CRASH_CNT 5
			int sndEsk_crash_current = 0;
			SOUND* sndEsk_crash[SNDESK_CRASH_CNT];
			
		// Pengin shout
			#define SNDPEN_CRASH_CNT 2
			int sndPen_crash_current = 0;
			SOUND* sndPen_crash[SNDPEN_CRASH_CNT];