//////////////////////////////////////////////////////////////////////
// RUDI v0.1 - an open source Christmas game
// Copyright (C) 2007 Christian Behrenberg
//--------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//--------------------------------------------------------------------
// module       : RUDI main file
// created (by) : Christian Behrenberg, 2007-10-10
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// switches
//--------------------------------------------------------------------

	#define COMPILE

//--------------------------------------------------------------------
// pre-processor
//--------------------------------------------------------------------

	//- acknex & liteC linkage ---------------------------------------
		#include <acknex.h>

		#ifndef COMPILE
			#include <default.c>
		#endif

	//- system libs --------------------------------------------------
		#include <stdio.h>
		
	//- game ---------------------------------------------------------
	
		//paths for nested include files
		
			#define PRAGMA_PATH "sys"
			#define PRAGMA_PATH "game"
			#define PRAGMA_PATH "debug"
			#define PRAGMA_PATH "%EXE_DIR%\\code"
		
		//debug
			#ifndef COMPILE
				#include "deb.c"		//debug
			#endif

		//headers
			#include "sys.h"				//framework

				#include "sysUtil.h"		//utilities
				#include "track.h"		//tracking
				#include "ri.h"			//res. independent display
				#include "shader.h"

			#include "game.h"				//game

				#include "player.h"		//player
				#include "cam.h"			//camera
				#include "sledge.h"		//sledge
				#include "packets.h"		//packets
				#include "levels.h"		//level management
				#include "effects.h"		//general effects
				#include "objects.h"
				#include "hud.h"
				#include "splash.h"
				#include "menu.h"
				#include "environment.h"
				#include "npc.h"
				#include "actors.h"
				#include "credits.h"
				#include "music.h"
				#include "sounds.h"

		//codefiles
			#include "sys.c"				//framework

				#include "sysUtil.c";	//utilities
				#include "track.c"		//tracking
				#include "ri.c"			//res. independent display

				#include "shader.c"

			#include "game.c"				//game

				#include "player.c"		//player
				#include "cam.c"			//camera
				#include "sledge.c"		//sledge
				#include "packets.c"		//packets
				#include "levels.c"		//level management
				#include "effects.c"		//general effects
				#include "objects.c"
				#include "hud.c"
				#include "splash.c"
				#include "menu.c"
				#include "environment.c"
				#include "npc.c"
				#include "actors.c"
				#include "credits.c"
				#include "music.c"
				#include "sounds.c"

//--------------------------------------------------------------------
// main
//--------------------------------------------------------------------
void main ()
{
	sys_main();	//start framework
	game();		//start game
}