//////////////////////////////////////////////////////////////////////
// RUDI v0.1 - an open source Christmas game
// Copyright (C) 2007 Christian Behrenberg
//--------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//--------------------------------------------------------------------
// module       : system -- HEADER
// created (by) : Christian Behrenberg, 2007-10-10
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// PROTOTYPE HIERARCHY
//--------------------------------------------------------------------

	void sys_main();
		void sys_init();
			void sys_video_init();
			void sys_keys_init();
				void sys_key_null();
		void sys_loop();
			void sys_keys_check();
			void sys_key_freeze();
	void sys_close();

//--------------------------------------------------------------------
// DEFINES
//--------------------------------------------------------------------

	#define DEF_VIDEO_RES	8	// 1024x768
	#define DEF_VIDEO_DEPTH	32	// 32 bit color

	#ifndef COMPILE
		#define DEF_VIDEO_MODE	2	// Window
	#else
		#define DEF_VIDEO_MODE	1	// Fullscreen
	#endif

	STRING* DEF_WINDOW_TITLE = "RUDI";
	
	#define SECOND 16 //ticks per second

//--------------------------------------------------------------------
// GLOBALS
//--------------------------------------------------------------------

	// Abstract button states
		int UP, DOWN, LEFT, RIGHT;
	
//--------------------------------------------------------------------
// GLOBAL TEMP VARIABLES
//--------------------------------------------------------------------	

	VECTOR	vecTemp, vecTemp2, vecTemp3, vecTemp4;
	var		varTemp[8];
	ENTITY*	entTemp[8];
	STRING	strTemp, strTemp2, strTemp3;